/************************************************************************
* File Name    : MPU6050_lib.c
* Version      : 1.00
* Device(s)    : R5F100LE
* Tool-Chain   : CCRL
* Description  : This file implements device driver for MPU6050.
* Creation Date: 2022/08/21
*************************************************************************/
/************************************************************************
Includes
*************************************************************************/
#include "r_cg_macrodriver.h"
#include "r_cg_serial.h"
#include "r_cg_userdefine.h"
#include "MPU6050_lib.h"

/************************************************************************
Global variables and functions
*************************************************************************/
/*------------------------------------------------------
    MPU6050f[^i[pobt@̈
-------------------------------------------------------*/
volatile int16_t    g_MPU6050[7];           // MPU6050vf[^
/*
[0]:g_accel_x;          // Xx
[1]:g_accel_y;          // Yx
[2]:g_accel_z;          // Zx
[3]:g_temp;             // x
[4]:g_gyro_x;           // Xpx
[5]:g_gyro_y;           // Ypx
[6]:g_gyro_z;           // Zpx
*/

volatile uint8_t    g_IIC_r_buffer[14];     // MPU6050ǂݏopobt@
volatile uint8_t    g_IIC_w_buffer[2];      // MPU6050ݗpobt@

/***********************************************************************
* Function Name: R_IIC11_MPU6050_Init
* Description  : ̊֐MPU6050X^oCԂ烊[X܂B
* Arguments    : Ȃ
* Return Value : ʐMXe[^X
*               0x01 : 튮
*               0x81 : ʐMG[
************************************************************************/
uint8_t R_IIC11_MPU6050_Init(void)
{

    uint8_t work;

    g_IIC_w_buffer[0] = PWR_MGMT_1;         // MPU6050p[䃌WX^AhXݒ
    g_IIC_w_buffer[1] = 0x00;               // MPU6050̃X[vԉf[^ibit6=0)
    work = R_IIC11_Master_Send3(SADDR7*2, (uint8_t * __near)g_IIC_w_buffer, 2);   // X[vR}hM

    if ( 0x01 != work )
    {                                       // ʐMG[
        P6_bit.no2 = 0;                     // G[LED_
    }
    else
    {
        R_IIC11_StopCondition();            // I2CoXɃXgbvRfBVs
    }

    return (work);

}   /* end of function R_IIC11_MPU6050_Init */

/***********************************************************************
* Function Name: R_IIC11_MPU6050_Read_data
* Description  : ̊֐MPU6050Sf[^ǂݏo܂B
* Arguments    : Ȃ
* Return Value : ʐMXe[^X
*               0x01 : 튮
*               0x81 : ʐMG[
************************************************************************/
uint8_t R_IIC11_MPU6050_Read_data(void)
{

    uint8_t work;
    uint8_t i;

/*------------------------------------------------------
    MPU6050̃WX^EAhXݒ
-------------------------------------------------------*/
    g_IIC_w_buffer[0] = ACCEL_XOUT;         // Xxf[^̃AhXݒ

    work = R_IIC11_Master_Send3(SADDR7*2, (uint8_t * __near)g_IIC_w_buffer, 1);  // WX^AhXM

    if ( 0x01 != work )                     // ʐMʊmF
    {                                       // ʐMG[
        P6_bit.no2 = 0;                     // G[LED_
    }
    else
    {                                       // AhXݒ芮ȂǂݏoJn

/*------------------------------------------------------
    MPU6050̃WX^ǂݏo
-------------------------------------------------------*/

        R_IIC11_StopCondition();            // I2CoXɃXgbvRfBVs

        work = R_IIC11_Master_Receiv3(SADDR7*2, (uint8_t * __near)g_IIC_r_buffer, 14);

        if ( 0x01 != work )
        {                                   // ʐMG[
            P6_bit.no2 = 0;                 // G[LED_
        }
        else
        {
            R_IIC11_StopCondition();        // I2CoXɃXgbvRfBVs

/*------------------------------------------------------
    MPU6050f[^iuint8^int16^ɃpbNj
-------------------------------------------------------*/

            for ( i = 0 ; i < 7 ; i++ )
            {
                g_MPU6050[i] = ( g_IIC_r_buffer[(i*2)] << 8 );
                g_MPU6050[i] += g_IIC_r_buffer[(i*2+1)];
            }

        }
    }

    return (work);

}   /* end of function R_IIC11_MPU6050_Read_data    */

